# -*- coding: utf-8 -*-

import datetime

from django.utils.translation import ugettext_lazy as _
import admin_tools
from admin_tools.dashboard import modules, register, AppIndexDashboard

from jmb.core.admin import dashboard as jmb_dashboard


class DefaultDashboard(modules.Group):
    def __init__(self, **kwargs):

        today = datetime.date.today()
        kwargs = {
            'title': "Fileapi",
            'display': "tabs",
            'children': [
                # CustomModule(
                #     title='Today Fileapi',
                #     order_by='-date_create',
                #     limit=None,
                #     extra_filters={'date_create__gte': today},
                # ),
                Models(),
                # OtherModels(),
                # FileapiSettings(),
                # Permissions(),
            ]
        }
        super(DefaultDashboard, self).__init__(**kwargs)


class FileapiDashboard(modules.Group):
    def __init__(self, **kwargs):

        today = datetime.date.today()
        kwargs = {
            'title': "Fileapi",
            'display': "tabs",
            'children': [
                Models(),
                # OtherModels(),
                # Settings(),
                # Permissions(),
            ]
        }
        super(FileapiDashboard, self).__init__(**kwargs)


class Models(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs = {
            'title': _("Main Models"),
            'models': ('jmb.fileapi.models.*',),
        }
        super(Models, self).__init__(**kwargs)


class OtherModels(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs = {
            'title': _("Others"),
            'models': (),
        }
        super(OtherModels, self).__init__(**kwargs)


class DefaultAppDashboard(AppIndexDashboard):
    def __init__(self, app_title, models, **kwargs):
        AppIndexDashboard.__init__(self, app_title, models, **kwargs)
        self.columns = 3

    def init_with_context(self, context):
        request = context['request']

        # Registered dashboards
        self.children.append(
            DefaultDashboard(),
        )

# Used in /admin 
jmb_dashboard.register_group(FileapiDashboard, 'jmb.fileapi')
# Used in /admin/Fileapi
admin_tools.dashboard.register(DefaultAppDashboard, 'jmb.fileapi')
